JUCE: ImageConvolutionKernel Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ImageConvolutionKernel Class Reference
juce_graphics » images

Represents a filter kernel to use in convoluting an image. More...

`#include <juce_ImageConvolutionKernel.h>`

## Public Member Functions
| ImageConvolutionKernel (int size)
| Creates an empty convolution kernel.
| ~ImageConvolutionKernel ()
| Destructor.
void | clear ()
| Resets all values in the kernel to zero.
float | getKernelValue (int x, int y) const noexcept
| Returns one of the kernel values.
void | setKernelValue (int x, int y, float value) noexcept
| Sets the value of a specific cell in the kernel.
void | setOverallSum (float desiredTotalSum)
| Rescales all values in the kernel to make the total add up to a fixed value.
void | rescaleAllValues (float multiplier)
| Multiplies all values in the kernel by a value.
void | createGaussianBlur (float blurRadius)
| Initialises the kernel for a gaussian blur.
int | getKernelSize () const
| Returns the size of the kernel.
void | applyToImage (Image &destImage, const Image &sourceImage, const Rectangle< int > &destinationArea) const
| Applies the kernel to an image.

## Detailed Description

Represents a filter kernel to use in convoluting an image.

See also
  Image::applyConvolution

## Constructor & Destructor Documentation

## ◆ ImageConvolutionKernel()

ImageConvolutionKernel::ImageConvolutionKernel | ( | int | size | ) |

Creates an empty convolution kernel.

Parameters

  size | the length of each dimension of the kernel, so e.g. if the size is 5, it will create a 5x5 kernel

## ◆ ~ImageConvolutionKernel()

ImageConvolutionKernel::~ImageConvolutionKernel | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ clear()

void ImageConvolutionKernel::clear | ( |  | ) |

Resets all values in the kernel to zero.

## ◆ getKernelValue()

float ImageConvolutionKernel::getKernelValue | ( | int | x,
|  | int | y ) const
| noexcept

Returns one of the kernel values.

## ◆ setKernelValue()

void ImageConvolutionKernel::setKernelValue | ( | int | x,
|  | int | y,
|  | float | value )
| noexcept

Sets the value of a specific cell in the kernel.

The x and y parameters must be in the range 0 < x < getKernelSize().

See also
  setOverallSum

## ◆ setOverallSum()

void ImageConvolutionKernel::setOverallSum | ( | float | desiredTotalSum | ) |

Rescales all values in the kernel to make the total add up to a fixed value.

This will multiply all values in the kernel by (desiredTotalSum / currentTotalSum).

## ◆ rescaleAllValues()

void ImageConvolutionKernel::rescaleAllValues | ( | float | multiplier | ) |

Multiplies all values in the kernel by a value.

## ◆ createGaussianBlur()

void ImageConvolutionKernel::createGaussianBlur | ( | float | blurRadius | ) |

Initialises the kernel for a gaussian blur.

Parameters

  blurRadius | this may be larger or smaller than the kernel's actual size but this will obviously be wasteful or clip at the edges. Ideally the kernel should be just larger than (blurRadius * 2).

## ◆ getKernelSize()

int ImageConvolutionKernel::getKernelSize | ( |  | ) | const

Returns the size of the kernel.

E.g. if it's a 3x3 kernel, this returns 3.

## ◆ applyToImage()

void ImageConvolutionKernel::applyToImage | ( | Image & | destImage,
|  | const Image & | sourceImage,
|  | const Rectangle< int > & | destinationArea ) const

Applies the kernel to an image.

Parameters

  destImage | the image that will receive the resultant convoluted pixels.
  sourceImage | the source image to read from - this can be the same image as the destination, but if different, it must be exactly the same size and format.
  destinationArea | the region of the image to apply the filter to

The documentation for this class was generated from the following file:

- juce_ImageConvolutionKernel.h